unit question1_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TfrmQuestion1 = class(TForm)
    Label7: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edtName: TEdit;
    Label2: TLabel;
    edtEmail: TEdit;
    btnRegister: TButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    edtCost: TEdit;
    sedNumMeals: TSpinEdit;
    chbVegetarian: TCheckBox;
    btnCalcCost: TButton;
    GroupBox3: TGroupBox;
    btnCalcTablesPower: TButton;
    Label5: TLabel;
    edtNumPlayers: TEdit;
    Label6: TLabel;
    Label9: TLabel;
    edtNumTables: TEdit;
    edtPower: TEdit;
    GroupBox4: TGroupBox;
    btnCalculate: TButton;
    cbMealOptions: TComboBox;
    Label12: TLabel;
    edtUnits: TEdit;
    Label13: TLabel;
    edtDailyusage: TEdit;
    memDisplay: TMemo;
    procedure btnCalcTablesPowerClick(Sender: TObject);
    procedure btnRegisterClick(Sender: TObject);
    procedure btnCalculateClick(Sender: TObject);
    procedure btnCalcCostClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion1: TfrmQuestion1;


implementation

{$R *.dfm}

procedure TfrmQuestion1.btnRegisterClick(Sender: TObject);

begin
   // Question 1.1
   if (edtName.text > '') AND (edtEmail.Text > '') then
    showMessage(edtName.text + ' with e-mail address ' + edtEmail.text + ' has been registered.')
   else
     showMessage('Not all the required data was provided.');
end;




procedure TfrmQuestion1.btnCalcCostClick(Sender: TObject);
var
 iNumOfMeals : Integer;
 rMealPrice, rMealsCost : Real;
 sMealDescrpt : String;
begin
  // Question 1.2
   case cbMealOptions.ItemIndex of
     0:   rMealPrice := 25;
     1:   rMealPrice := 32.80;
     2:   rMealPrice := 45.75;
   end;

  iNumOfMeals := sedNumMeals.Value;
  rMealsCost := iNumOfMeals * rMealPrice;

  if chbVegetarian.checked then
    rMealsCost := rMealsCost * 0.9;
  edtCost.Font.Color := clBlue;
  edtCost.text := FloatToStrF(rMealsCost,ffCurrency,10,2);
end;

procedure TfrmQuestion1.btnCalcTablesPowerClick(Sender: TObject);
CONST
   TableSize = 6;
var
 iNumPlayers, iNumTables, iNumOnTable, iPower: Integer;
begin
   // Question 1.3
   iNumPlayers := StrToInt(edtNumPlayers.text);

   iNumTables := iNumPlayers DIV TableSize;
   if iNumPlayers MOD TableSize > 0 then
     Inc(iNumTables);
   //iNumTables := Round(iNumPlayers/TableSize + 0.4999);

   iPower := Round(iNumPlayers * 0.66);
   edtPower.text := IntToStr(iPower);
   edtNumTables.text := IntToStr(iNumTables);
end;


procedure TfrmQuestion1.btnCalculateClick(Sender: TObject);
var
  iUnits, iUsage, iCount: integer;

begin
  // Question 1.4
  memDisplay.clear;
  iUnits := StrToInt(edtUnits.text);
  iUsage := Random(100) + 50;
  edtDailyUsage.text := IntToStr(iusage);
  iCount := 0;
  while iUnits >= iUsage do
  begin
    Inc(iCount);
    iUnits := iUnits - iUsage;
    memDisplay.lines.add('Units after day ' + IntToStr(iCount) + ' : ' + IntToStr(iUnits));
  end;

end;


end.
